Attribute VB_Name = "FlatenTheMap"
Public ByteArray() As Byte
Public TagID() As Double
Public TagOffset() As Double
Public TagMetaSize() As Double
Public TagTag() As String
Public MapMagicVal

Public SBSPMeshOffs
Public SBSPMeshSize
Public SBSPVertOff
Public SBSPIndiOff
Public SBSPVertSiz
Public SBSPIndiSiz

Public Makeitflatvalue

Public Function Endian(hexttext)
xtemp = Right("0000000" & hexttext, 8)
tText = ""
For xx = 1 To 4
'DoMyEvents
tText = tText & StrReverse(Right(Left(xtemp, xx * 2), 2))
Next xx
Endian = StrReverse(tText)
End Function

Public Sub LocateBSP(ScnrSize, ScnrOffset, scnrindexoff, SbspIndexOff, CollTake)
Dim sbspheadoff As Double, j As Double
sbspheadoff = Load4Hex(ScnrOffset + 532, True) - MapMagicVal
SBSPOffset = Load4Hex(sbspheadoff, True)
SBSPSize = Load4Hex(sbspheadoff + 4, True)
SBSPMagic = Load4Hex(sbspheadoff + 8, True)

'###############################################################
If CollTake > 0 Then

tdata = Load4Hex(SBSPOffset + 40, True) - SBSPMagic
tstart = Load4Hex(SBSPOffset + tdata + 60, True) - SBSPMagic
tstart = tstart + SBSPOffset
tend = tstart + (Load4Hex(SBSPOffset + tdata + 56, True) * 16) ' verticies size

For tScroll = tstart To tend Step 12
'DoMyEvents
myx = Endian(ConvertToFloat(Makeitflatvalue))
ByteArray(tScroll + 8) = HexToDec(Right(Left(CStr(myx), 2), 2))
ByteArray(tScroll + 9) = HexToDec(Right(Left(CStr(myx), 4), 2))
ByteArray(tScroll + 10) = HexToDec(Right(Left(CStr(myx), 6), 2))
ByteArray(tScroll + 11) = HexToDec(Right(Left(CStr(myx), 8), 2))
Next tScroll

End If

If CollTake = 2 Then
GoTo skipit
End If

'###############################################################

sbspmeshcount = Load4Hex(SBSPOffset + 172, True)
sbspmeshheadoff = Load4Hex(SBSPOffset + 176, True) - SBSPMagic


ReDim SBSPMeshOffs(0 To sbspmeshcount)
ReDim SBSPMeshSize(0 To sbspmeshcount)
ReDim SBSPVertOff(0 To sbspmeshcount)
ReDim SBSPIndiOff(0 To sbspmeshcount)
ReDim SBSPVertSiz(0 To sbspmeshcount)
ReDim SBSPIndiSiz(0 To sbspmeshcount)

k = 0

For i = 0 To sbspmeshcount * 176 Step 176
'DoMyEvents
 SBSPMeshOffs(k) = Load4Hex(sbspmeshheadoff + SBSPOffset + i + 40, True)
 SBSPMeshSize(k) = Load4Hex(sbspmeshheadoff + SBSPOffset + i + 44, True)
 k = k + 1
Next i

For i = 0 To sbspmeshcount
'DoMyEvents
 For j = SBSPMeshOffs(i) To SBSPMeshOffs(i) + SBSPMeshSize(i) - 5 Step 4
  'DoMyEvents
  If Load4Hex(j, True) = 1920168547 Then
   s = s + 1
   If s = 3 Then
    SBSPIndiOff(i) = j + 4
   ElseIf s = 4 Then
    SBSPIndiSiz(i) = j - SBSPIndiOff(i)
   ElseIf s = 7 Then
    SBSPVertOff(i) = j + 4
   ElseIf s = 8 Then
    SBSPVertSiz(i) = j - SBSPVertOff(i)
   End If
  End If
 Next j
s = 0
Dim tmp7 As String
Dim tmp8 As String
Dim tmp9 As String
Dim tmp10 As String

Next i

For i = 0 To sbspmeshcount
DoMyEvents
 tmp7 = ""
 tmp8 = ""
 tmp9 = ""
 tmp10 = ""
 
 tcount = 0
 
 For j = SBSPVertOff(i) To SBSPVertOff(i) + SBSPVertSiz(i)
 'DoMyEvents
 tcount = tcount + 1
 
  If tcount = 9 Then
    myx = Endian(ConvertToFloat(Makeitflatvalue))
    ByteArray(j + 0) = HexToDec(Right(Left(CStr(myx), 2), 2))
    ByteArray(j + 1) = HexToDec(Right(Left(CStr(myx), 4), 2))
    ByteArray(j + 2) = HexToDec(Right(Left(CStr(myx), 6), 2))
    ByteArray(j + 3) = HexToDec(Right(Left(CStr(myx), 8), 2))
  End If
  
  If tcount = 12 Then
    tcount = 0
  End If

 Next j
 
Next i

skipit:

FunckTheMap "Flat/Map/by/Glitch/n/Jefff"

savemap

End Sub

Public Sub savemap()

ByteArray(0) = 100
ByteArray(1) = 97
ByteArray(2) = 101
ByteArray(3) = 104
ByteArray(4) = 8

Fmap = FreeFile
Open App.Path & "\ChangedMap.map" For Binary As Fmap
DoMyEvents
Put #Fmap, , ByteArray
Close #Fmap
MsgBox "Where All Done Here" & vbNewLine & "EverThing Went Good", vbSystemModal + vbExclamation + vbOKOnly, "Every Thing Is Done"
End Sub

Public Sub Makeitflat(mymapfile, CollTake, heightthis)

Makeitflatvalue = heightthis

Dim i As Double

MapMagicVal = MapMagic(mymapfile)

indexheader = Load4Hex(16, True)

tagcount = Load4Hex(indexheader + 4, True)
rtagoff = indexheader + 32 + tagcount * 12
rtagcount = Load4Hex(indexheader + 24, True)
etagoff = rtagoff + rtagcount * 16
 
ReDim TagTag(0 To rtagcount + 1)
ReDim TagID(0 To rtagcount + 1)
ReDim TagOffset(0 To rtagcount + 1)
ReDim TagMetaSize(0 To rtagcount + 1)


For i = rtagoff To etagoff Step 4
DoMyEvents
 tmp1 = Load4String(i, True)
 If LCase(tmp1) = "scnr" Then
  scnrindexoff = i
 ElseIf LCase(tmp1) = "sbsp" Then
  SbspIndexOff = i
 End If
Next i

ScnrSize = Load4Hex(scnrindexoff + 12, True)
ScnrOffset = Load4Hex(scnrindexoff + 8, True) - MapMagicVal

LocateBSP ScnrSize, ScnrOffset, scnrindexoff, SbspIndexOff, CollTake

End Sub

Public Function MapMagic(mapfile)
Dim indexheader As Double
Fno = FreeFile
fileName = mapfile
Open fileName For Binary As #Fno
    DoMyEvents
    SizeOfFile = LOF(Fno)
    ReDim ByteArray(0 To SizeOfFile - 1) As Byte
    DoMyEvents
    Get #Fno, , ByteArray
Close #Fno
 
For i = 0 To 32
 'DoMyEvents
 If ByteArray(408 + i) <> 0 Then mapname = mapname + Chr$(ByteArray(408 + i))
Next i

indexheader = Load4Hex(16, True)
indexmagic = Load4Hex(indexheader, True) - (Load4Hex(16, True) + 32)
ntemp = Load4Hex((Load4Hex(indexheader + 8, True) - indexmagic) + 8, True) - (indexheader + Load4Hex(20, True))
MapMagic = ntemp
End Function

Public Function Load4String(ByRef offset As Double, r As Boolean) As String
tmp1 = Chr$(ByteArray(offset + 0))
tmp2 = Chr$(ByteArray(offset + 1))
tmp3 = Chr$(ByteArray(offset + 2))
tmp4 = Chr$(ByteArray(offset + 3))
If r = False Then
Load4String = tmp1 + tmp2 + tmp3 + tmp4
Else
Load4String = tmp4 + tmp3 + tmp2 + tmp1
End If
End Function

Public Function Load4Hex(ByRef sbyte As Double, r As Boolean) As Double
tmp1 = Hex(ByteArray(sbyte + 0))
tmp2 = Hex(ByteArray(sbyte + 1))
tmp3 = Hex(ByteArray(sbyte + 2))
tmp4 = Hex(ByteArray(sbyte + 3))
If Len(tmp1) = 1 Then tmp1 = "0" + tmp1
If Len(tmp2) = 1 Then tmp2 = "0" + tmp2
If Len(tmp3) = 1 Then tmp3 = "0" + tmp3
If Len(tmp4) = 1 Then tmp4 = "0" + tmp4
If r = True Then
tmp5 = tmp4 + tmp3 + tmp2 + tmp1
Else
tmp5 = tmp1 + tmp2 + tmp3 + tmp4
End If
Load4Hex = HexToDec(tmp5)
End Function

Public Function Load2Hex(ByRef sbyte As Double, r As Boolean) As Double
tmp1 = Hex(ByteArray(sbyte + 0))
tmp2 = Hex(ByteArray(sbyte + 1))
If Len(tmp1) = 1 Then tmp1 = "0" + tmp1
If Len(tmp2) = 1 Then tmp2 = "0" + tmp2
If r = True Then
tmp3 = tmp2 + tmp1
Else
tmp3 = tmp1 + tmp2
End If
Load2Hex = HexToDec(tmp3)
End Function

Public Function HexToDec(ByVal HexStr As String) As Double
Dim mult As Double
Dim DecNum As Double
Dim ch As String
Dim i As Integer
mult = 1
DecNum = 0
For i = Len(HexStr) To 1 Step -1
'DoMyEvents
    ch = Mid(HexStr, i, 1)
    If (ch >= "0") And (ch <= "9") Then
        DecNum = DecNum + (Val(ch) * mult)
    Else
        If (ch >= "A") And (ch <= "F") Then
            DecNum = DecNum + ((Asc(ch) - Asc("A") + 10) * mult)
        Else
            If (ch >= "a") And (ch <= "f") Then
                DecNum = DecNum + ((Asc(ch) - Asc("a") + 10) * mult)
            Else
                HexToDec = 0
                Exit Function
            End If
        End If
    End If
    mult = mult * 16
Next i
HexToDec = DecNum
End Function


