Attribute VB_Name = "SpConvertion"
Public ByteArray2() As Byte
Public MapMagicVal2
Public MPbsp
Public SPbsp

Public Sub SPtoMp(spFile, mpFile)
MapMagicVal2 = MapMagic2(spFile)
MapMagicVal = MapMagic(mpFile)



'#################################################
'mp
indexheader = Load4Hex(16, True)
tagcount = Load4Hex(indexheader + 4, True)
rtagoff = indexheader + 32 + tagcount * 12
rtagcount = Load4Hex(indexheader + 24, True)
etagoff = rtagoff + rtagcount * 16
'#################################################
For i = rtagoff To etagoff Step 4
tmp1 = Load4String(CStr(i), True)
If LCase(tmp1) = "scnr" Then
scnrindexoff = i
ElseIf LCase(tmp1) = "sbsp" Then
SbspIndexOff = i
End If
Next i
ScnrOffset = Load4Hex(scnrindexoff + 8, True) - MapMagicVal
sbspheadoff = Load4Hex(ScnrOffset + 532, True) - MapMagicVal
SBSPOffset = Load4Hex(CStr(sbspheadoff), True)
SBSPMagic = Load4Hex(CStr(sbspheadoff) + 8, True)
'#################################################
'#################################################
'sp
indexheader = Load4Hex2(16, True)
tagcount = Load4Hex2(indexheader + 4, True)
rtagoff = indexheader + 32 + tagcount * 12
rtagcount = Load4Hex2(indexheader + 24, True)
etagoff = rtagoff + rtagcount * 16
'#################################################
For i = rtagoff To etagoff Step 4
tmp1 = Load4String2(CStr(i), True)
If LCase(tmp1) = "scnr" Then
scnrindexoff = i
ElseIf LCase(tmp1) = "sbsp" Then
SbspIndexOff = i
End If
Next i
ScnrOffset = Load4Hex2(scnrindexoff + 8, True) - MapMagicVal2
sbspheadoff = Load4Hex2(ScnrOffset + 532, True) - MapMagicVal2
SBSPOffset2 = Load4Hex2(CStr(sbspheadoff), True)
SBSPMagic2 = Load4Hex2(sbspheadoff + 8, True)
'#################################################


'#################################################
sbspmeshcount2 = Load4Hex2(SBSPOffset2 + 172, True)
sbspmeshheadoff2 = Load4Hex2(SBSPOffset2 + 176, True) - SBSPMagic2
totalsize = 0
For i = 0 To sbspmeshcount2 * 176 Step 176
'SBSPMeshOffs(k) = Load4Hex(sbspmeshheadoff + SBSPOffset + i + 40, True)
totalsize = totalsize + Load4Hex2(sbspmeshheadoff2 + SBSPOffset2 + i + 44, True)
Next i
'#################################################


'###############################################################
tdata = Load4Hex2(SBSPOffset2 + 40, True) - SBSPMagic2
tstart = Load4Hex2(SBSPOffset2 + tdata + 60, True) - SBSPMagic2
tstart = tstart + SBSPOffset2
tend = tstart + (Load4Hex2(SBSPOffset2 + tdata + 56, True) * 16) ' verticies size
'###############################################################
tstart2 = Load4Hex2(SBSPOffset2 + tdata + 52, True) - SBSPMagic2
tstart2 = tstart2 + SBSPOffset2
tend2 = tstart2 + (Load4Hex2(SBSPOffset2 + tdata + 48, True) * 12) ' indies size
'###############################################################


'###############################################################
xtstart = Load4Hex(SBSPOffset + tdata + 60, True) - SBSPMagic
xtend = tstart + (Load4Hex(SBSPOffset + tdata + 56, True) * 16) ' verticies size
'###############################################################
xtstart2 = Load4Hex(SBSPOffset + tdata + 52, True) - SBSPMagic
xtend2 = tstart2 + (Load4Hex(SBSPOffset + tdata + 48, True) * 12) ' indies size
'###############################################################

timesbigger = 25

'###############################################################
'find cd lenth then clear it
putat = FileLen(mpFile)
mapcdcd = cdcd(UBound(ByteArray))
For ddtemp = putat - mapcdcd - 1 To putat - 1
ByteArray(ddtemp) = 0
Next ddtemp
'###############################################################

ReDim Preserve ByteArray(UBound(ByteArray) + (65536 * CInt(timesbigger)))

'totalsize

ntemp = putat
ntemp = ntemp + SBSPMagic
ntemp = BigDecToHex(ntemp)
ntemp = Endian(ntemp)
writeit ntemp, SBSPOffset + 176
writeit Endian(hex(sbspmeshcount2)), SBSPOffset + 172

t = UBound(ByteArray)

y = sbspmeshheadoff2
For tx = putat To putat + totalsize
ByteArray(tx) = ByteArray2(y)
y = y + 1
Next tx


For tr = UBound(ByteArray) To UBound(ByteArray) - mapcdcd Step -1
ByteArray(tr) = 205
Next tr


a = Load4Hex(8, True)
writeit Endian(hex(a + (65536 * CInt(timesbigger)))), 8

a = Load4Hex(24, True)
writeit Endian(hex(a + (65536 * CInt(timesbigger)))), 8

a = Load4Hex(28, True)
writeit Endian(hex(a + (65536 * CInt(timesbigger)))), 8


Fmap = FreeFile
Open CStr(mpFile) & ".map" For Binary As Fmap
DoMyEvents
Put #Fmap, , ByteArray
Close #Fmap


End Sub

Private Sub writeit(hex, numb)
tcount = 0
For X = 1 To Len(hex) Step 2
ntemp = Right(Left(hex, X + 1), 2)
ByteArray(numb + tcount) = CByte(HexToDec(ntemp))
tcount = tcount + 1
Next X
End Sub

Public Function BigDecToHex(ByVal DecNum) As String

    ' This function is 100% accurate untill
    '     15,000,000,000,000,000 (1.5E+16)
    Dim NextHexDigit As Double
    Dim HexNum As String
    HexNum = ""


    While DecNum <> 0
    NextHexDigit = DecNum - (Int(DecNum / 16) * 16)


    If NextHexDigit < 10 Then
        HexNum = Chr(Asc(NextHexDigit)) & HexNum
    Else
        HexNum = Chr(Asc("A") + NextHexDigit - 10) & HexNum
    End If

    DecNum = Int(DecNum / 16)
Wend

If HexNum = "" Then HexNum = "0"
BigDecToHex = HexNum
End Function


Private Function cdcd(mapsize)
For tempx = mapsize - 3 To 0 Step -1
temptext = CStr(hex(ByteArray(tempx)))
If LCase(temptext) <> "cd" Then
cdcd = mapsize - (tempx + 1)
Exit Function
End If
Next tempx
End Function

Public Function MapMagic2(mapfile)
Dim indexheader As Double
Fno = FreeFile
fileName = mapfile
Open fileName For Binary As #Fno
    DoMyEvents
    SizeOfFile = LOF(Fno)
    ReDim ByteArray2(0 To SizeOfFile - 1) As Byte
    DoMyEvents
    Get #Fno, , ByteArray2
Close #Fno
 
For i = 0 To 32
 'DoMyEvents
 If ByteArray2(408 + i) <> 0 Then mapname = mapname + Chr$(ByteArray2(408 + i))
Next i

indexheader = Load4Hex2(16, True)
indexmagic = Load4Hex2(indexheader, True) - (Load4Hex2(16, True) + 32)
ntemp = Load4Hex2((Load4Hex2(indexheader + 8, True) - indexmagic) + 8, True) - (indexheader + Load4Hex2(20, True))
MapMagic2 = ntemp
End Function

Public Function Load4Hex2(ByRef sbyte As Double, r As Boolean) As Double
tmp1 = hex(ByteArray2(sbyte + 0))
tmp2 = hex(ByteArray2(sbyte + 1))
tmp3 = hex(ByteArray2(sbyte + 2))
tmp4 = hex(ByteArray2(sbyte + 3))
If Len(tmp1) = 1 Then tmp1 = "0" + tmp1
If Len(tmp2) = 1 Then tmp2 = "0" + tmp2
If Len(tmp3) = 1 Then tmp3 = "0" + tmp3
If Len(tmp4) = 1 Then tmp4 = "0" + tmp4
If r = True Then
tmp5 = tmp4 + tmp3 + tmp2 + tmp1
Else
tmp5 = tmp1 + tmp2 + tmp3 + tmp4
End If
Load4Hex2 = HexToDec(tmp5)
End Function

Public Function Load4String2(ByRef offset As Double, r As Boolean) As String
tmp1 = Chr$(ByteArray2(offset + 0))
tmp2 = Chr$(ByteArray2(offset + 1))
tmp3 = Chr$(ByteArray2(offset + 2))
tmp4 = Chr$(ByteArray2(offset + 3))
If r = False Then
Load4String2 = tmp1 + tmp2 + tmp3 + tmp4
Else
Load4String2 = tmp4 + tmp3 + tmp2 + tmp1
End If
End Function
